## ros-one-laser-filters 1.9.1-0noble.20251023.1103

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(laser_filters)

##############################################################################
# Find dependencies
##############################################################################

set(THIS_PACKAGE_ROS_DEPS sensor_msgs roscpp tf filters message_filters
  laser_geometry pluginlib angles dynamic_reconfigure nodelet)

find_package(catkin REQUIRED COMPONENTS ${THIS_PACKAGE_ROS_DEPS})
find_package(Boost REQUIRED COMPONENTS system)
include_directories(include ${catkin_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS})

##############################################################################
# Define package
##############################################################################

# dynamic reconfigure
generate_dynamic_reconfigure_options(
  cfg/IntensityFilter.cfg
  cfg/PolygonFilter.cfg
  cfg/RangeFilter.cfg
  cfg/ScanShadowsFilter.cfg
  cfg/SpeckleFilter.cfg
  cfg/SectorFilter.cfg
  cfg/BoxFilter.cfg
)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES pointcloud_filters laser_scan_filters
  CATKIN_DEPENDS ${THIS_PACKAGE_ROS_DEPS}
  DEPENDS
  )

##############################################################################
# Build
##############################################################################

add_library(pointcloud_filters src/pointcloud_filters.cpp)
target_link_libraries(pointcloud_filters ${catkin_LIBRARIES})

add_library(laser_scan_filters
  src/laser_scan_filters.cpp
  src/median_filter.cpp
  src/array_filter.cpp
  src/box_filter.cpp
  src/polygon_filter.cpp
  src/scan_shadow_detector.cpp
  src/scan_shadows_filter.cpp
  src/speckle_filter.cpp
  src/intensity_filter.cpp
  src/sector_filter.cpp
)
target_link_libraries(laser_scan_filters ${catkin_LIBRARIES} ${Boost_LIBRARIES})

add_executable(scan_to_cloud_filter_chain src/scan_to_cloud_filter_chain.cpp)
target_link_libraries(scan_to_cloud_filter_chain ${catkin_LIBRARIES} ${Boost_LIBRARIES})

add_executable(scan_to_scan_filter_chain src/scan_to_scan_filter_chain.cpp)
target_link_libraries(scan_to_scan_filter_chain ${catkin_LIBRARIES} ${Boost_LIBRARIES})

add_library(${PROJECT_NAME}_nodelets
  src/scan_to_cloud_filter_chain.cpp
  src/scan_to_scan_filter_chain.cpp)
target_link_libraries(${PROJECT_NAME}_nodelets ${catkin_LIBRARIES} ${Boost_LIBRARIES})
target_compile_definitions(${PROJECT_NAME}_nodelets PRIVATE BUILDING_NODELET=1)

add_executable(generic_laser_filter_node src/generic_laser_filter_node.cpp)
target_link_libraries(generic_laser_filter_node ${catkin_LIBRARIES} ${Boost_LIBRARIES})

add_dependencies(laser_scan_filters ${PROJECT_NAME}_gencfg)

if (CATKIN_ENABLE_TESTING)
  if (CATKIN_ENABLE_PERFORMANCE_TESTING)
    message(STATUS "Enabling performance tests")
    add_definitions(-DENABLE_PERFORMANCE)
  else()
    message(STATUS "Disabled performance tests")
  endif()

  find_package(rostest)

  add_rostest_gtest(test_scan_filter_chain test/test_scan_filter_chain.launch test/test_scan_filter_chain.cpp)
  target_link_libraries(test_scan_filter_chain laser_scan_filters ${catkin_LIBRARIES})
  add_rostest(test/test_polygon_filter.launch)
  add_rostest(test/test_speckle_filter.launch)

  catkin_add_gtest(test_shadow_detector test/test_shadow_detector.cpp)
  target_link_libraries(test_shadow_detector laser_scan_filters ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  catkin_add_gtest(test_speckle_filter test/test_speckle_filter.cpp)
  target_link_libraries(test_speckle_filter laser_scan_filters ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  catkin_add_gtest(test_scan_shadows_filter test/test_scan_shadows_filter.cpp)
  target_link_libraries(test_scan_shadows_filter laser_scan_filters ${catkin_LIBRARIES} ${rostest_LIBRARIES})
endif()

##############################################################################
# Install
##############################################################################

install(TARGETS pointcloud_filters laser_scan_filters 
  scan_to_cloud_filter_chain
  scan_to_scan_filter_chain
  ${PROJECT_NAME}_nodelets
  generic_laser_filter_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# Install headers
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(FILES laser_filters_plugins.xml nodelets.xml
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

## ros-one-laser-filters 1.9.1-0jammy.20251023.1043

=== debian/changelog ===
ros-one-laser-filters (1.9.1-0jammy.20251023.1043) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Jon Binney <jon.binney@gmail.com>  Thu, 23 Oct 2025 10:43:53 +0000

ros-one-laser-filters (1.9.1-0jammy) jammy; urgency=high

  * Fix polygon padding on filter load
  * Added nodelet for scan filtering pipeline
  * Pass in public node handle from nodelet to allow for correct topic remapping
  * Do not force obsolete C++11 standard
  * Boxfilter dynamic reconfigure for noetic devel
  * Make transform time-out configurable
  * Do not look for specific time in static filter
  * Added examples for InterpolationFilter and LaserScanAngularBoundsFilter
  * Added example config and launch file for scan blob filter
  * Add static polygon filter
  * Improve shadov filter and detector performance
  * Speed up speckle filter implementation
  * Contributors: Bohdan Yarema, Erwin Bonsma, Giorgos Tsamis, Jon Binney, Lars, Lucas Walter, Michael Ripperger, johntgz, rickvanosch, v4hn

 -- Jon Binney <jon.binney@gmail.com>  Wed, 17 Jul 2024 00:00:00 -0000

ros-one-laser-filters (1.9.0-0jammy) jammy; urgency=high

  * change_access specifier kinect
  * Added nodelet version of scan_to_cloud_filter_chain .
  * fix(speckle_filter): Possible segfault when ranges size was smaller than filter window
    formatting
  * Lots of fixes to CI
  * scan_to_cloud_filter_chain: Make cloud channels configurable
  * Fixed naming of laser filter plugins in yaml files
  * Add circle sector sharp filter
  * Added DynamicReconfigure for RangeFilter
  * Added support for laserscanners that spin clockwise
  * Added nodelet version of scan_to_cloud_filter_chain .
  * Contributors: Arjanboeve, Eric Wiener, Jimmy F. Klarke, Jonathan Binney, Martin Pecka, Rein Appeldoorn, YoshuaNava, renan028, teundeplanque

 -- Jon Binney <jon.binney@gmail.com>  Sat, 06 Nov 2021 00:00:00 -0000

ros-one-laser-filters (1.8.11-0jammy) jammy; urgency=high

  * Merge pull request #97 <https://github.com/ros-perception/laser_filters/issues/97> from eurogroep/feat/speckle-filter-for-noise-removal
  * Merge pull request #96 <https://github.com/ros-perception/laser_filters/issues/96> from eurogroep/feat/intensity-filter-dynamic-reconfigure-and-optionally-override-intensity-values
    feat(IntensityFilter): Dynamic reconfigure and optionally override intensity
  * Merge pull request #3 <https://github.com/ros-perception/laser_filters/issues/3> from nlimpert/nlimpert/speckle-filter-radius-outlier-merge
    Merge distance based speckle filter with RadiusOutlier removal
  * Contributors: Jonathan Binney, Nicolas Limpert, Rein Appeldoorn

 -- Jon Binney <jon.binney@gmail.com>  Wed, 03 Jun 2020 00:00:00 -0000

ros-one-laser-filters (1.8.10-0jammy) jammy; urgency=high

  * radius_outlier_filter: new filter for radius based outlier removal
    Add a new filter to remove measurements that do not have a number of
    neighbors within a certain range.
  * Contributors: Jonathan Binney, Nicolas Limpert

 -- Jon Binney <jon.binney@gmail.com>  Tue, 07 Apr 2020 00:00:00 -0000

ros-one-laser-filters (1.8.9-0jammy) jammy; urgency=high

  * Bump CMake version to avoid CMP0048 warning
  * Polygon filter
  * Add dynamic reconfigure for scan shadows filter
  * Parameter to remove shadow start point in scan shadows filter
  * Contributors: Jonathan Binney, Rein Appeldoorn, Yannick_de_Hoop, ahcorde

 -- Jon Binney <jon.binney@gmail.com>  Sun, 05 Apr 2020 00:00:00 -0000

ros-one-laser-filters (1.8.8-0jammy) jammy; urgency=high

  * Merge pull request #83 <https://github.com/ros-perception/laser_filters/issues/83> from remco-r/indigo-devel
    [fix] when high fidelity true added laser_max_range_ to projection
  * [fix] when high fidelity true added laser_max_range_ to projection
  * Merge pull request #79 <https://github.com/ros-perception/laser_filters/issues/79> from Jailander/indigo-devel
    Adding invert filter parameter to BOX filter
  * Merge pull request #80 <https://github.com/ros-perception/laser_filters/issues/80> from k-okada/indigo-devel
    Add scan blob filters
  * add scan blob filters
  * Merge pull request #72 <https://github.com/ros-perception/laser_filters/issues/72> from ms-iot/windows_port_tests_fix
    [Windows][indigo] Use ${GTEST_LIBRARIES} for more portable gtest library linkage.
  * Adding invert filter parameter to BOX filter
  * Remove extra changes.
  * windows bring up
  * Contributors: Jonathan Binney, Kei Okada, Remco, Sean Yen, jailander

 -- Jon Binney <jon.binney@gmail.com>  Thu, 07 Nov 2019 00:00:00 -0000

ros-one-laser-filters (1.8.7-0jammy) jammy; urgency=high

  * Merge pull request #77 <https://github.com/ros-perception/laser_filters/issues/77> from bionade24/indigo-devel
    Removed boost signals from CMakeLists.txt
  * Removed boost signals from CMakeLists.txt
    With boost=>1.69 there signals isn't available anymore. As it's not necessary, it should be removed to be compatible to all boost versions.
  * Merge pull request #76 <https://github.com/ros-perception/laser_filters/issues/76> from peci1/fix_travis
    Fix Travis and move on to Kinetic and Lunar.
  * Fix Travis and move on to Kinetic and Lunar.
  * Merge pull request #73 <https://github.com/ros-perception/laser_filters/issues/73> from peci1/patch-1
    Added error message when the filter chain failed.
  * Added error message when the filter chain failed.
  * Merge pull request #62 <https://github.com/ros-perception/laser_filters/issues/62> from at-wat/optimize-shadows-filter
    Reduce computation cost of ScanShadowsFilter
  * Merge pull request #63 <https://github.com/ros-perception/laser_filters/issues/63> from procopiostein/indigo-devel
    set values for variables that could be used uninitialized
  * Add some comments to ScanShadowDetector
  * set values for variables that could be used uninitialized
  * Reduce computation cost of ScanShadowsFilter
    ScanShadowsFilter required a lot of CPU power mainly due to atan2.


=== debian/control ===
Source: ros-one-laser-filters
Section: misc
Priority: optional
Maintainer: Jon Binney <jon.binney@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-one-angles, ros-one-catkin, ros-one-dynamic-reconfigure, ros-one-filters, ros-one-laser-geometry, ros-one-message-filters, ros-one-nodelet, ros-one-pluginlib, ros-one-roscpp, ros-one-rostest, ros-one-sensor-msgs, ros-one-tf
Homepage: http://ros.org/wiki/laser_filters
Standards-Version: 3.9.2

Package: ros-one-laser-filters
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-one-angles, ros-one-dynamic-reconfigure, ros-one-filters, ros-one-laser-geometry, ros-one-message-filters, ros-one-nodelet, ros-one-pluginlib, ros-one-roscpp, ros-one-sensor-msgs, ros-one-tf
Description: Assorted filters designed to operate on 2D planar laser scanners, which use the sensor_msgs/LaserScan type.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-laser-filters//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-laser-filters 1.9.1-0jammy.20251207.2314

=== debian/changelog ===
ros-one-laser-filters (1.9.1-0jammy.20251207.2314) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Jon Binney <jon.binney@gmail.com>  Sun, 07 Dec 2025 23:14:48 +0000

## ros-one-laser-filters 1.9.1-0jammy.20260221.2208

=== debian/changelog ===
ros-one-laser-filters (1.9.1-0jammy.20260221.2208) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Jon Binney <jon.binney@gmail.com>  Sat, 21 Feb 2026 22:08:38 +0000

## ros-one-laser-filters 1.9.1-0noble.20251023.1103

=== debian/changelog ===
ros-one-laser-filters (1.9.1-0noble.20251023.1103) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Jon Binney <jon.binney@gmail.com>  Thu, 23 Oct 2025 11:03:10 +0000

ros-one-laser-filters (1.9.1-0noble) noble; urgency=high

  * Fix polygon padding on filter load
  * Added nodelet for scan filtering pipeline
  * Pass in public node handle from nodelet to allow for correct topic remapping
  * Do not force obsolete C++11 standard
  * Boxfilter dynamic reconfigure for noetic devel
  * Make transform time-out configurable
  * Do not look for specific time in static filter
  * Added examples for InterpolationFilter and LaserScanAngularBoundsFilter
  * Added example config and launch file for scan blob filter
  * Add static polygon filter
  * Improve shadov filter and detector performance
  * Speed up speckle filter implementation
  * Contributors: Bohdan Yarema, Erwin Bonsma, Giorgos Tsamis, Jon Binney, Lars, Lucas Walter, Michael Ripperger, johntgz, rickvanosch, v4hn

 -- Jon Binney <jon.binney@gmail.com>  Wed, 17 Jul 2024 00:00:00 -0000

ros-one-laser-filters (1.9.0-0noble) noble; urgency=high

  * change_access specifier kinect
  * Added nodelet version of scan_to_cloud_filter_chain .
  * fix(speckle_filter): Possible segfault when ranges size was smaller than filter window
    formatting
  * Lots of fixes to CI
  * scan_to_cloud_filter_chain: Make cloud channels configurable
  * Fixed naming of laser filter plugins in yaml files
  * Add circle sector sharp filter
  * Added DynamicReconfigure for RangeFilter
  * Added support for laserscanners that spin clockwise
  * Added nodelet version of scan_to_cloud_filter_chain .
  * Contributors: Arjanboeve, Eric Wiener, Jimmy F. Klarke, Jonathan Binney, Martin Pecka, Rein Appeldoorn, YoshuaNava, renan028, teundeplanque

 -- Jon Binney <jon.binney@gmail.com>  Sat, 06 Nov 2021 00:00:00 -0000

ros-one-laser-filters (1.8.11-0noble) noble; urgency=high

  * Merge pull request #97 <https://github.com/ros-perception/laser_filters/issues/97> from eurogroep/feat/speckle-filter-for-noise-removal
  * Merge pull request #96 <https://github.com/ros-perception/laser_filters/issues/96> from eurogroep/feat/intensity-filter-dynamic-reconfigure-and-optionally-override-intensity-values
    feat(IntensityFilter): Dynamic reconfigure and optionally override intensity
  * Merge pull request #3 <https://github.com/ros-perception/laser_filters/issues/3> from nlimpert/nlimpert/speckle-filter-radius-outlier-merge
    Merge distance based speckle filter with RadiusOutlier removal
  * Contributors: Jonathan Binney, Nicolas Limpert, Rein Appeldoorn

 -- Jon Binney <jon.binney@gmail.com>  Wed, 03 Jun 2020 00:00:00 -0000

ros-one-laser-filters (1.8.10-0noble) noble; urgency=high

  * radius_outlier_filter: new filter for radius based outlier removal
    Add a new filter to remove measurements that do not have a number of
    neighbors within a certain range.
  * Contributors: Jonathan Binney, Nicolas Limpert

 -- Jon Binney <jon.binney@gmail.com>  Tue, 07 Apr 2020 00:00:00 -0000

ros-one-laser-filters (1.8.9-0noble) noble; urgency=high

  * Bump CMake version to avoid CMP0048 warning
  * Polygon filter
  * Add dynamic reconfigure for scan shadows filter
  * Parameter to remove shadow start point in scan shadows filter
  * Contributors: Jonathan Binney, Rein Appeldoorn, Yannick_de_Hoop, ahcorde

 -- Jon Binney <jon.binney@gmail.com>  Sun, 05 Apr 2020 00:00:00 -0000

ros-one-laser-filters (1.8.8-0noble) noble; urgency=high

  * Merge pull request #83 <https://github.com/ros-perception/laser_filters/issues/83> from remco-r/indigo-devel
    [fix] when high fidelity true added laser_max_range_ to projection
  * [fix] when high fidelity true added laser_max_range_ to projection
  * Merge pull request #79 <https://github.com/ros-perception/laser_filters/issues/79> from Jailander/indigo-devel
    Adding invert filter parameter to BOX filter
  * Merge pull request #80 <https://github.com/ros-perception/laser_filters/issues/80> from k-okada/indigo-devel
    Add scan blob filters
  * add scan blob filters
  * Merge pull request #72 <https://github.com/ros-perception/laser_filters/issues/72> from ms-iot/windows_port_tests_fix
    [Windows][indigo] Use ${GTEST_LIBRARIES} for more portable gtest library linkage.
  * Adding invert filter parameter to BOX filter
  * Remove extra changes.
  * windows bring up
  * Contributors: Jonathan Binney, Kei Okada, Remco, Sean Yen, jailander

 -- Jon Binney <jon.binney@gmail.com>  Thu, 07 Nov 2019 00:00:00 -0000

ros-one-laser-filters (1.8.7-0noble) noble; urgency=high

  * Merge pull request #77 <https://github.com/ros-perception/laser_filters/issues/77> from bionade24/indigo-devel
    Removed boost signals from CMakeLists.txt
  * Removed boost signals from CMakeLists.txt
    With boost=>1.69 there signals isn't available anymore. As it's not necessary, it should be removed to be compatible to all boost versions.
  * Merge pull request #76 <https://github.com/ros-perception/laser_filters/issues/76> from peci1/fix_travis
    Fix Travis and move on to Kinetic and Lunar.
  * Fix Travis and move on to Kinetic and Lunar.
  * Merge pull request #73 <https://github.com/ros-perception/laser_filters/issues/73> from peci1/patch-1
    Added error message when the filter chain failed.
  * Added error message when the filter chain failed.
  * Merge pull request #62 <https://github.com/ros-perception/laser_filters/issues/62> from at-wat/optimize-shadows-filter
    Reduce computation cost of ScanShadowsFilter
  * Merge pull request #63 <https://github.com/ros-perception/laser_filters/issues/63> from procopiostein/indigo-devel
    set values for variables that could be used uninitialized
  * Add some comments to ScanShadowDetector
  * set values for variables that could be used uninitialized
  * Reduce computation cost of ScanShadowsFilter
    ScanShadowsFilter required a lot of CPU power mainly due to atan2.


## ros-one-laser-filters 1.9.1-0noble.20260221.2303

=== debian/changelog ===
ros-one-laser-filters (1.9.1-0noble.20260221.2303) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Jon Binney <jon.binney@gmail.com>  Sat, 21 Feb 2026 23:03:25 +0000
